
#ifdef WIN32
	#include <windows.h>
	#pragma comment(lib, "Irrlicht.lib")
#endif

#include <irrlicht.h>

using namespace irr;
using namespace core;
using namespace video;
using namespace scene;
using namespace gui;

#include <math.h>

#define div 45
#define PI 3.141592654
float vertex[div][div][3];
float rad = (float)PI/180.0f;

//_񏉊
void init()
{
	int i,j=0;
	float v = 360/div;//1̓x
	for(i=0;i<div;i++)
	{
		for(j=0;j<div;j++)
		{
			vertex[i][j][0]=float((i*5.0)/div-2.5);//-2.5`2.5͈̔͂
			vertex[i][j][1]=float((j*5.0)/div-2.5);//-2.5`2.5͈̔͂
			vertex[i][j][2]=float(sin(i*v*rad));//1.0`-1.0
		}
	}
}

void makeScene(IVideoDriver *driver)
{
	int x,y;
	float hold;
	float x1,y1,x2,y2;
	u16 list[] = {0,1,2, 2,1,3};
	S3DVertex ver[4];

	//eNX`ǂݍ
	ITexture* Texture;
	Texture = driver->getTexture("wall.bmp");
	SMaterial Material;
	Material.Lighting = false;
	Material.BackfaceCulling = false;
	Material.TextureLayer[0].Texture = Texture;
	driver->setMaterial(Material);


	for(x=0;x<div-1;x++)
	{
		for(y=0;y<div-1;y++)
		{
			x1 = float(x  )/(div-1);
			y1 = float(y  )/(div-1);
			x2 = float(x+1)/(div-1);
			y2 = float(y+1)/(div-1);

			ver[0] = S3DVertex(vertex[x  ][y  ][0], vertex[x  ][y  ][1], vertex[x  ][y  ][2], 0,0,1, 0xFFFFFFFF, x1,y1);
			ver[1] = S3DVertex(vertex[x+1][y  ][0], vertex[x+1][y  ][1], vertex[x+1][y  ][2], 0,0,1, 0xFFFFFFFF, x2,y1);
			ver[2] = S3DVertex(vertex[x  ][y+1][0], vertex[x  ][y+1][1], vertex[x  ][y+1][2], 0,0,1, 0xFFFFFFFF, x1,y2);
			ver[3] = S3DVertex(vertex[x+1][y+1][0], vertex[x+1][y+1][1], vertex[x+1][y+1][2], 0,0,1, 0xFFFFFFFF, x2,y2);
			driver->drawIndexedTriangleList(&ver[0], 4, &list[0], 2);
		}
	}

	//_(Z)XV
	for(y=0;y<div;y++)
	{
		hold = vertex[0][y][2];
		for(x=0;x<div-1;x++)
		{
			vertex[x][y][2] = vertex[x+1][y][2];
		}
		vertex[div-1][y][2] = hold;
	}
}

#ifdef WIN32
	int WINAPI WinMain(HINSTANCE hInst, HINSTANCE hPrevInst, LPSTR strCmdLine, int nShowCmd)
#else
	int main()
#endif
{
	IrrlichtDevice *device  = createDevice(EDT_OPENGL,dimension2d<s32>(320,240),16,false,false,false);
	IVideoDriver *driver    = device->getVideoDriver();
	ISceneManager* smgr     = device->getSceneManager();

	device->setWindowCaption(L"Irrlicht");//EChE^Cgݒ

	//Cg
//	smgr->addLightSceneNode(0, vector3df(0,0,-1000), SColorf(0xFFFFFFFF), 1000.0f);
	
	//Jݒ
	smgr->addCameraSceneNode(0, vector3df(0,0,-5), vector3df(0,0,0));//ʏJ

	init();

	while(device->run())
	{
		driver->beginScene(true,true,0xFF6060FF);

		//}`쐬
		makeScene(driver);

		//V[̕`
		smgr->drawAll();

		driver->endScene();
	}

	driver->drop();

	return 0;
}
